
TARGET = exercise11_part02
CURDIR = $(shell pwd)

BUILD_KERNEL = "/lib/modules/$(shell uname -r)/build"
# BUILD_KERNEL = "/home/yura/basecamp/Linux_Kernel_GL_Basecamp/linux-5.6.12/linux_build"

obj-m := src/$(TARGET).o

.PHONY: all clean
all:
	$(MAKE) -C $(BUILD_KERNEL) M=$(CURDIR) modules
clean:
	$(MAKE) -C $(BUILD_KERNEL) M=$(CURDIR) clean


test:
	sudo dmesg -C
	echo "Before insmod ..."
	- ls -al /dev/dyn_*
	sudo insmod src/$(TARGET).ko
	echo "After insmod ..."
	ls -al /dev/dyn_*
	ls -al /sys/class/ | grep dyn
	cat /proc/devices | grep dyn
	- cat /proc/modules | grep dyn
	sudo cat /dev/dyn_0
	sudo cat /dev/dyn_1
	sudo cat /dev/dyn_2
	ls -al /sys/class/dyn_class
	tree /sys/devices/virtual/dyn_class/dyn_1
	sudo rmmod $(TARGET)
	echo "After rmmod ..."
	- ls -al /dev/dyn_*
	dmesg

# 	sudo insmod src/exercise11_part02.ko
# 	sudo rmmod exercise11_part02
#   cat /sys/class/dyn_class/dyn_0

